SystemOrganization addCategory: #'Glamour-Examples'!

Object subclass: #GLMExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

GLMExamples subclass: #GLMBasicExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMBasicExamples commentStamp: 'tg 9/11/2009 15:57' prior: 0!
self browseExamples!

!GLMBasicExamples methodsFor: 'private' stamp: 'tg 7/31/2009 22:55'!
actionsFor: aPresentation 
	|actions|
	aPresentation isMultiple 
							ifTrue: [actions := (aPresentation selection) ifNil: [OrderedCollection new]]
							ifFalse: [actions := OrderedCollection with: aPresentation selection ].
	^ actions collect: [:i |
					(GLMAction new) 
						action: [:each | Transcript show: 'Menu - Item', i printString; cr]; 
						title: 'Menu - Item', i printString; 
						yourself ]! !

!GLMBasicExamples methodsFor: 'file examples' stamp: 'tg 9/11/2009 15:38'!
fileExplorer
	<glmBrowser: 'File Explorer' input: 'FileDirectory default'>
	"self new fileExplorer openOn: FileDirectory default"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser 
		column: #folders;
		column: [ :col | col row: #files span: 2; row: #preview ] span: 2. 
	browser showOn: #folders; using: [
		browser tree 
			title: 'Folders'; 
			children: [ :fd | fd directoryNames collect: [ :each | FileDirectory on: fd pathName, fd pathNameDelimiter asString, each ] ]; 
			format: [ :folder | folder localName ] ].
	browser showOn: #files; from: #folders; using: [
		browser list 
			format: [ :fd | fd localName ]; 
			display: [ :fd | fd fileNames collect: [:each | FileDirectory on: fd pathName, fd pathNameDelimiter asString, each ] ] ].
	browser showOn: #preview; from: #files; using: [
		browser text
			display: [ :file | (FileStream readOnlyFileFullyNamed: file fullName) contents ] ].
	^ browser! !

!GLMBasicExamples methodsFor: 'file examples' stamp: 'tg 9/11/2009 15:43'!
fileFinder
	<glmBrowser: 'File Finder' input: 'FileDirectory default'>
	"self new fileFinder openOn: FileDirectory default"

	| browser |
	browser := GLMFinder new.
	browser list
		display: [ :fd | fd entries collect: [:each | FileDirectory on: fd pathName, fd pathNameDelimiter asString, each name]];
		format: [ :fd | fd localName ];
		when: [ :fd | fd directoryEntry isDirectory ].
	browser text
		display: [ :fd | (FileStream readOnlyFileFullyNamed: fd fullName) contents ];
		when: [ :fd | fd directoryEntry isDirectory not ].
	^ browser! !

!GLMBasicExamples methodsFor: 'others' stamp: 'tg 9/11/2009 15:53'!
interdependentPanes
	<glmBrowser: 'Inter-dependent Panes' input: '5'>
	"self new interdependentPanes openOn: 5"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	browser showOn: #one; from: #two; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	^ browser! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 9/9/2009 02:15'!
multiInitialSelection
	"
		| browser |
		browser := self new multiInitialSelection.
		browser openOn: 5.
		(browser panes first port: #selection) value: #(2 5 3).
	"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser list
			beMultiple;
			display: [:x | 1 to: x * 3]].
	browser showOn: #two; from: #one; using: [
		browser list ].
	^ browser! !

!GLMBasicExamples methodsFor: 'menu examples' stamp: 'tg 9/11/2009 16:00'!
multipleFinderWithSearch
	<glmBrowser: 'Multiple List with Menu and Search' input: '$a to: $z'>
	"self new multipleFinderWithSearch openOn: ($a to: $z)"

	| finder |	
	finder := GLMFinder new.
	finder list
			beMultiple;
			actions: [:list | self actionsFor: list];
			searchOn: [:text :list | list select: (Compiler evaluate: '[:each | | entity | ', text, ']')].
	^ finder ! !

!GLMBasicExamples methodsFor: 'tabs examples' stamp: 'tg 9/11/2009 15:58'!
multipleTabs
	<glmBrowser: 'Multiple Tabs' input: '1'>
	"self new multipleTabs openOn: 1"
	
	| finder |
	finder := GLMFinder new.
	(1 to: 9) do: [:i | 
		finder text
			title: 'Text ', i printString;
			display: [:x | i printString].
	].
	^ finder! !

!GLMBasicExamples methodsFor: 'pier examples' stamp: 'tg 8/31/2009 14:20'!
pierFinder
	"
		self new pierFinder openOn: PRKernel instances anyOne root.
	"
	| browser |
	browser := GLMFinder new.
	browser list
		display: [:each | each enumerator contents];
		format: [:each | each title];
		title: 'Navigation'.
	browser magritte title: 'Editor'.
	browser mondrian
			title: 'Tree';
			painting: [:view :each | 
				view nodeShape: (MORectangleShape withBorder height: [:x | x plainText size // 10]).
				view nodes: each enumerator everything contents.
				view edgesFrom: #parent.
				view treeLayout].
	^ browser! !

!GLMBasicExamples methodsFor: 'pier examples' stamp: 'tg 5/6/2009 13:31'!
pierTreeEditor

	"
		self new pierTreeEditor openOn: PRKernel instances anyOne root.
	"

	| browser |
	browser := GLMTableLayoutBrowser new.
	browser column: #navigation; column: #editor span: 4.
	browser showOn: #navigation; using: [
		browser tree
			children: [:each | each enumerator contents];
			format: [:each | each title ];
			title: 'Navigation'.
	].
	browser showOn: #editor; from: #navigation; using: [
		browser magritte
			title: 'Editor'.
	].
	^ browser ! !

!GLMBasicExamples methodsFor: 'menu examples' stamp: 'tg 9/11/2009 16:00'!
simpleFinderWithMenu
	<glmBrowser: 'Finder with Menu' input: '$z'>
	"self new simpleFinderWithMenu openOn: $z"

	| finder |
	finder := GLMFinder new.
	finder list
			title: 'List';
			display: [:each | $a to: each];
			actions: [:list | self actionsFor: list ].
	^ finder! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 9/10/2009 15:31'!
singleInitialSelection
	"
		| browser |
		browser := self new singleInitialSelection.
		browser openOn: 5.
		(browser panes first port: #selection) value: 2.
	"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser list
			display: [:x | 1 to: x * 3];
			format: [:number | Text string: number printString attribute: TextColor red]].
	browser showOn: #two; from: #one; using: [
		browser list
			display: [:x | 1 to: x * 3]].
	^ browser! !

!GLMBasicExamples methodsFor: 'menu examples' stamp: 'tg 9/11/2009 15:59'!
staticAndDynamicMenu
	<glmBrowser: 'Static and Dynamic Menu' input: '$z'>
	"self new staticAndDynamicMenu openOn: $z"

	| finder |
	finder := GLMFinder new.
	finder list
			title: 'List';
			display: [:each | $a to: each];
			actions: [:list | self actionsFor: list ];
			act: [Transcript show: 'static action'; cr] entitled: 'Static action';
			act: [Transcript show: 'static sub action'; cr] entitled: 'Static sub action' categorized: 'Sub menu'.
	finder text
			title: 'Text';
			display: [:each | 'Character ', each asString];
			actions: [:text | OrderedCollection with: (GLMAction new title: 'Print selection'; action: [Transcript show: text selection]; yourself) ];
			act: [Transcript show: 'Text static action'] entitled: 'Static action'.
	^ finder! !

!GLMBasicExamples methodsFor: 'explicit selection' stamp: 'tg 9/10/2009 22:07'!
treeWithInitialSelection
	"
		| browser |
		browser := self new treeWithInitialSelection. 
		browser openOn: {
			#first->{$a->{}. $c->{}. $d->{}}.
			#second->{$e->{}. $f->{}}. 
			#third->{$h->{}}
		}.
		(browser panes first port: #selection) value: $a->{}.
	"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			children: [:x | x value ]].
	browser showOn: #two; from: #one; using: [ browser text ].
	^ browser! !

!GLMBasicExamples methodsFor: 'menu examples' stamp: 'tg 9/11/2009 16:02'!
treeWithMenu
	<glmBrowser: 'Tree with Menu' input: '#(($a $b $c $d) ($e $f) ($g $h $i $j $l))'>
	"self new treeWithMenu openOn: #(($a $b $c $d) ($e $f) ($g $h $i $j $l))"
	|browser |

	browser := GLMTableLayoutBrowser new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			children: [:x | x asString size > 1 ifTrue: [x] ifFalse: [OrderedCollection new] ]];
			act: [] on: $d entitled: 'Some action'.
	browser showOn: #two; from: #one; using: [ browser text ].
	^ browser! !

!GLMExamples classSide methodsFor: 'as yet unclassified' stamp: 'tg 9/11/2009 15:56'!
browseExamples
	"self browseExamples"
	| browser pragmas |
	pragmas := Pragma 
		allNamed: #glmBrowser:input:
		in: self.
	browser := GLMTableLayoutBrowser new.
	browser title: self name asString.
	browser column: #titles; column: #example span: 4.
	browser showOn: #titles; using: [
		browser list
			format: [:each | each argumentAt: 1]].
	browser showOn: #example; from: #titles; using: [
		browser dynamic
			display: [:each | (self new perform: each selector) startOn: (Compiler evaluate: (each argumentAt: 2) logged: false)]].
	browser openOn: pragmas.! !

GLMExamples subclass: #GLMSmalltalkExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSmalltalkExamples commentStamp: 'tg 9/11/2009 16:10' prior: 0!
self browseExamples!

!GLMSmalltalkExamples methodsFor: 'st examples' stamp: 'tg 9/1/2009 08:31'!
messageTally
	"self new messageTally openOn: (
	MessageTally new spyEvery: 1 on: [10000 timesRepeat: [1.23 printString]]; yourself)"

	| browser finder |
	finder := GLMFinder new.
	finder list
		title: 'Messages';
		display: [:each | each sonsOver: -1];
		format: [:each | each printString, ' (', each tally printString, ')'].
	browser := GLMTableLayoutBrowser new.
	browser row: #messages; row: #source.
	browser showOn: #messages; using: [browser custom: finder].
	browser showOn: #source; from: #messages; using: [
		browser text
		title: 'Source';
		display: [:each | each method methodClass sourceCodeAt: each method selector ifAbsent: ['unknown']]
	].
	browser 
		act: [:x |
			(StringHolder new contents: (String streamContents: [:s | x entity report: s; close])) openLabel: 'Spy Results' wrap: false.]
		entitled: 'Print report'.	
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'st examples' stamp: 'tg 9/11/2009 16:09'!
messageTallyTree
	<glmBrowser: 'Message Tally Tree' input: 'MessageTally new spyEvery: 1 on: [10000 timesRepeat: [1.23 printString]]; yourself'>
	"self new messageTallyTree openOn: (MessageTally new spyEvery: 1 on: [10000 timesRepeat: [1.23 printString]]; yourself)"

	| browser |
	browser := GLMTableLayoutBrowser new.
	browser column: #messages; column: #details.
	browser showOn: #messages; using: [
		browser tree
			children: [:each | each sonsOver: -1 ];
			format: [:each | Text fromString: (each printString, ' (', each tally printString, ')')]].
	browser showOn: #details; from: #messages; using: [
		browser text
			forSmalltalk: [:each | each method methodClass];
			display: [:each | each method methodClass sourceCodeAt: each method selector ifAbsent: ['unknown']]].
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'others' stamp: 'tg 8/31/2009 23:39'!
metacelloBrowser
	"
		self new metacelloBrowser openOn: MetacelloMetacelloProject versions
	"
	| browser |

	browser := GLMTableLayoutBrowser new.
	browser title: 'Metacello Browser'.
	browser column: #versions; column: [:c | c row: #packages; row: #comment].
	browser showOn: #versions; using: [
		browser list
			act: [:list | list selection inspect] on: '/' entitled: 'Inspect'
	].
	browser showOn: #packages; from: #versions; using: [
		browser list
			title: 'Packages';
			display: [:version | version spec packages packageSpecsInLoadOrder ];
			format: [:package | package name];
			act: [:list | list selection inspect] on: '/' entitled: 'Inspect'.
		browser mondrian
			title: 'Dependencies';
			painting: [:view :version | 
				view nodes: version spec packages map values.
				].
		].
	browser showOn: #comment; from: #versions; using: [
		browser text
			title: 'Comment';
			display: [:version | version description] ].
	^ browser ! !

!GLMSmalltalkExamples methodsFor: 'st examples' stamp: 'tg 9/6/2009 17:53'!
objectFinder
	"
		self new objectFinder openOn: #(1 2 3 4)
	"
	| browser insideBrowser |
	insideBrowser := GLMTableLayoutBrowser new.
	browser := GLMFinder new.
	browser custom: insideBrowser.
	insideBrowser
		row: #object;
		row: #evaluator.
	insideBrowser
		showOn: #object;
		using: 
			[ insideBrowser list
				title: 'Collection';
				when: [ :anObject | anObject isCollection ].
			insideBrowser list
				title: [ :anObject | self printObjectAsAnItem: anObject ];
				display: 
					[ :anObject | 
					anObject class allInstVarNames collect: [ :iv | iv -> (anObject instVarNamed: iv) ] ];
				format: [ :assoc | assoc key asString , ' : ' , assoc value printString ];
				send: #value ].
	insideBrowser
		showOn: #evaluator;
		using: 
			[ insideBrowser text
				display: [ :entity | 'self' ];
				title: 'Evaluator';
				update: #selection
					on: $o
					entitled: 'Open (o)'
					with: 
						[ :text :entity | 
						Compiler 
							evaluate: text selectedText
							for: entity
							logged: false ] ].
	insideBrowser 
		sendToOutside: #selection
		from: #object.
	insideBrowser 
		sendToOutside: #selection
		from: #evaluator.
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'st examples' stamp: 'tg 9/11/2009 16:32'!
objectFinderTabbed
	<glmBrowser: 'Object Finder' input: 'Smalltalk'>
	"
		self new objectFinderTabbed openOn: Smalltalk
	"
	| browser |
	browser := GLMFinder new.
	browser list
		title: [ :anObject | self printObjectAsAnItem: anObject ];
		display: 
			[ :anObject | 
			anObject class allInstVarNames collect: [ :iv | iv -> (anObject instVarNamed: iv) ] ];
		format: [ :assoc | assoc key asString , ' : ' , (assoc value printString 	copyFrom: 1 to: ((50 min: assoc value printString size) max: 0)) ];
		send: #value.
	browser list
		title: 'Collection';
		when: [ :each | each isCollection ].
	browser text
		forSmalltalk;
		display: [ :entity | 'self' ];
		title: 'Evaluator';
		update: #selection
			on: $o
			entitled: 'Open (o)'
			with: 
				[ :text :entity | 
				Compiler 
					evaluate: text selectedText
					for: entity
					logged: false ];
		act: 
				[ :text :entity | 
				(Compiler 
					evaluate: text selectedText
					for: entity
					logged: false) inspect ]
			on: $/
			entitled: 'Inspect (/)'.
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'private' stamp: 'tg 9/6/2009 17:53'!
printObjectAsAnItem: anObject 
	| title stream |
	stream := String new writeStream.
	title := anObject class name.
	stream
		nextPutAll: (title first isVowel 
				ifTrue: [ 'an ' ]
				ifFalse: [ 'a ' ]);
		nextPutAll: title.
	^ stream contents! !

!GLMSmalltalkExamples methodsFor: 'st examples' stamp: 'tg 9/11/2009 16:33'!
smalldoc

	"self new smalldoc openOn: Smalltalk organization categories"
	"SGLDefaultComponent register: self new smalldoc on: Smalltalk organization categories"
	|browser|
	browser := GLMTableLayoutBrowser new.
	browser column: #classCats; column: #classes; column: #comment.
	browser showOn: #classCats; using: [
		browser list].
	browser showOn: #classes; from: #classCats; using: [
		browser list
			title: 'Classes';
			display: [:classCat | (Smalltalk organization listAtCategoryNamed: classCat) 
				collect: [:className | Smalltalk classNamed: className]];
			act: [:list | list selection inspect] entitled: 'Inspect'.
		"browser mondrian
			title: 'Hierarchies';
			painting: [:view :classCat | 
				classes := (Smalltalk organization listAtCategoryNamed: classCat) 
					collect: [:className | Smalltalk classNamed: className].
				view nodes: classes.
				view edgesFrom: #superclass.
				view treeLayout
			]"].
	browser showOn: #comment; from: #classes; using: [
		browser text
			display: [:class | class comment]].
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'st examples' stamp: 'DamienCassou 9/11/2009 10:09'!
stClassicBrowser
	"
		self new stClassicBrowser openOn: Smalltalk organization categories.
	"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser
		row: #navigation;
		row: #sourceCode.
	browser
		showOn: #navigation;
		using: [ browser custom: self stClassicNavigator ].
	browser
		showOn: #sourceCode;
		from: #navigation -> #selectedClass;
		from: #navigation -> #selectedMethod;
		from: #navigation -> #selectedClassCategory;
		using: 
			[ browser text
				title: 'Method source';
				display: [ :class :method | class sourceCodeAt: method ];
				forSmalltalk: [ :class | class ].
			browser text
				forSmalltalk;
				title: 'Class definition';
				display: [ :class | class definition ].
			browser text
				title: 'Class comment';
				display: [ :class | class comment ]].
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'st examples' stamp: 'DamienCassou 9/11/2009 10:04'!
stClassicNavigator
	"
		self new stClassicNavigator openOn: Smalltalk organization categories.
	"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser
		column: #classCats;
		column: #classes;
		column: #categories;
		column: #methods.
	browser
		showOn: #classCats;
		using: 
			[ browser list filterOn: [ :text :list | list select: [ :each | text match: each ] ] ].
	browser
		showOn: #classes;
		from: #classCats;
		using: 
			[ browser tree
				display: 
					[ :classCat | 
					(Smalltalk organization listAtCategoryNamed: classCat) collect: [ :className | Smalltalk classNamed: className ] ];
				children: [ :each | each traitComposition traits ];
				title: 'Class list'.
	browser mondrian painting: [ :view :package |
		view nodes: ((Smalltalk organization listAtCategoryNamed: package) collect: [:name | Smalltalk classNamed: name]).
		view edgesFrom: #superclass.
		view treeLayout.
	]; title: 'Hierarchy'.
 ].
	browser
		showOn: #categories;
		from: #classes;
		using: [ browser list display: [ :class | class organization categories ] ].
	browser
		showOn: #methods;
		from: #classes;
		from: #categories;
		using: 
			[ browser list
				display: 
					[ :class :category | 
					(class organization listAtCategoryNamed: category) asSortedCollection].
			browser list
				when: [ :class :category | class notNil and: [ category isNil ] ];
				display: [ :class :category | class selectors asSortedCollection ] ].
	browser 
		sendToOutside: #selectedClassCategory
		from: #classCats.
	browser 
		sendToOutside: #selectedClass
		from: #classes.
	browser 
		sendToOutside: #selectedMethod
		from: #methods.
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'st examples' stamp: 'tg 9/11/2009 19:08'!
stTreeBasedBrowser
	<glmBrowser: 'Tree Based Code Browser' input: 'GLMSTClassCategory all'>
	"self new stTreeBasedBrowser openOn: GLMSTClassCategory all"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser title: 'Glamorous Smallalk Browser'.
	browser
		column: #navigation;
		column: #sourceCode.
	browser
		showOn: #navigation;
		using: [ browser custom: self stTreeBasedNavigator ].
	browser
		showOn: #sourceCode;
		from: #navigation -> #selectedClass;
		from: #navigation -> #selectedMethod;
		from: #navigation -> #selectedClassCategory;
		using: 
			[ browser text
				title: 'Method source';
				display: [ :class :method | method sourceCode ];
				when: [ :class :method | method notNil and: [method isMethod] ];
				forSmalltalk: [ :class | class stBehavior ].
			browser text
				forSmalltalk;
				title: 'Class definition';
				display: [ :class | class definition ];
				when: [ :class | class notNil ].
			browser text
				title: 'Class comment';
				display: [ :class | class comment ];
				when: [ :class | class notNil ].
			].
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'st examples' stamp: 'tg 9/11/2009 19:12'!
stTreeBasedNavigator
	"
		self new stTreeBasedNavigator openOn: GLMSTClassCategory all
	"
	| browser |
	browser := GLMTableLayoutBrowser new.
	browser
		column: #classCats;
		column: [:c | c row: #classes span: 2; row: #classComment];
		column: [:c | c row: #instanceMethods span: 2; row: #metaMethods].
	browser showOn: #classCats; using: [ 
		browser list
			filterOn: [ :text :list | list select: [ :each | text match: each name ] ] ].
	browser showOn: #classes; from: #classCats; using: [
		browser tree 
			display: [ :classCat | classCat classes];
			children: [ :each | each traits ] ].
	browser showOn: #classComment; from: #classes; using: [
		browser text
			display: [:class | class comment]].
	browser showOn: #instanceMethods; from: #classes; using: [
		browser tree
			display: [ :class | class categories];
			children: [:catOrMethod | 
				catOrMethod isCategory ifTrue: [catOrMethod methods] ifFalse: [OrderedCollection new] ];
			send: [:catOrMethod | (catOrMethod notNil and: [catOrMethod isCategory]) ifTrue: [nil] ifFalse: [catOrMethod] ] ].
	browser showOn: #metaMethods; from: #classes; using: [
		browser tree
			display: [ :class | class metaSide categories];
			children: [:catOrMethod | 
				catOrMethod isCategory ifTrue: [catOrMethod methods] ifFalse: [OrderedCollection new] ];
			send: [:catOrMethod | (catOrMethod notNil and: [catOrMethod isCategory]) ifTrue: [nil] ifFalse: [catOrMethod] ] ].
	browser sendToOutside: #selectedClassCategory from: #classCats.
	browser sendToOutside: #selectedClass from: #classes.
	browser sendToOutside: #selectedMethod from: #instanceMethods.
	browser sendToOutside: #selectedMethod from: #metaMethods.
	^ browser! !

!GLMSmalltalkExamples methodsFor: 'st examples' stamp: 'tg 9/1/2009 16:25'!
traitsBrowser
	| browser codeBrowser |
	browser := GLMFinder new.
	browser list
		title: 'Classes'; 
		when: [:anObject | anObject isCollection and: [anObject anyOne isKindOf: Class]].
	browser list
		title: 'Methods';
		display: [:anObject | anObject selectors collect: [:each | anObject -> each ]];
		format: [:each | each value];
		when: [:anObject | (anObject isKindOf: Class) or: [anObject isKindOf: Trait]].
	browser list
		title: 'Traits';
		when: [:anObject | (anObject isKindOf: Class) or: [anObject isKindOf: Trait]];
		display: [:anObject | anObject traitComposition traits ].
	codeBrowser := GLMTableLayoutBrowser new.
	codeBrowser row: [:r | r column: #classes; column: #internals]; row: #details.
	codeBrowser showOn: #classes; using: [codeBrowser list].
	codeBrowser showOn: #internals; from: #classes; using: [codeBrowser custom: browser].
	codeBrowser showOn: #details; from: #internals; using: [
		codeBrowser text
			when: [:trait | trait isKindOf: Trait];
			display: [:trait | trait comment].
		codeBrowser text
			forSmalltalk;
			when: [:trait | trait isKindOf: Trait];
			display: [:trait | trait definition].
		codeBrowser text
			forSmalltalk: [:assoc | assoc key];
			when: [:assoc | (assoc isKindOf: Association)];
			display: [:assoc | assoc key sourceCodeAt: assoc value]].
	codeBrowser openOn: NSCollectionStream withAllSubclasses! !

Object subclass: #GLMSTBrowserExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTBrowserExample methodsFor: 'accessing' stamp: 'tg 8/31/2009 17:00'!
browser
	"
	self new browser openOn: (BrowserEnvironment new forPackageNamed: 'Glamour')
	"

	| browser |

	browser := GLMTableLayoutBrowser new.
	browser row: [ :row | 
		row 
			column: #category;
			column: #class;
			column: #protocol;
			column: #selector ].
	browser row: #source.
	
	" categories "
	self categoriesOn: browser.
	self classesOn: browser.
	self protocolsOn: browser.
	self selectorsOn: browser.
	self sourceOn: browser.
	
	^ browser! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/27/2009 15:09'!
categoriesOn: browser
	browser showOn: #category; using: [
		browser list
			display: [ :environment | environment categories ] ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/27/2009 15:09'!
classesOn: browser
	browser showOn: #class; from: #outer -> #entity; from: #category; using: [
		browser list
			title: 'Instance';
			display: [ :environment :category | 
				((environment classes select: [ :each | each isMeta not ])
					select: [ :each | each category = category ])
					asSortedCollection: [ :a :b | a name < b name ] ];
			format: [ :class | class name ].
		browser list
			title: 'Class';
			display: [ :environment :category | 
				((environment classes select: [ :each | each isMeta ])
					select: [ :each | each theNonMetaClass category = category ])
					asSortedCollection: [ :a :b | a name < b name ] ];
			format: [ :class | class theNonMetaClass name ] ]! !

!GLMSTBrowserExample methodsFor: 'accessing' stamp: 'lr 2/27/2009 10:35'!
model
	^ BrowserEnvironment new forPackageNamed: 'Glamour'! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 2/27/2009 15:08'!
protocolsOn: browser
	browser showOn: #protocol; from: #outer -> #entity; from: #class; using: [
		browser list
			when: [ :environment :class | class notNil ];
			display: [ :environment :class | 
				(environment protocolsFor: class)
					asSortedCollection ] ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'tg 8/31/2009 00:12'!
selectorsOn: browser
	browser showOn: #selector; from: #outer -> #entity; from: #class; from: #protocol; using: [
		browser list
			when: [ :environment :class :protocol | class notNil and: [ protocol notNil ] ];
			display: [ :environment :class :protocol | (environment selectorsFor: protocol in: class) asOrderedCollection ].
		browser list
			when: [ :environment :class :protocol | class notNil and: [ protocol isNil ] ];
			display: [ :environment :class :protocol | (environment selectorsForClass: class) asOrderedCollection ] ]! !

!GLMSTBrowserExample methodsFor: 'building' stamp: 'lr 3/12/2009 15:00'!
sourceOn: browser
	browser showOn: #source; from: #category; from: #class; from: #selector; using: [
		browser text
			title: 'Source';
			when: [ :category :class :selector | class notNil and: [ selector notNil ] ];
			display: [ :category :class :selector | class sourceCodeAt: selector ifAbsent: [ String new ] ].
		browser text
			title: 'Source';
			when: [ :category :class :selector | class notNil and: [ selector isNil ] ];
			display: [ :category :class :selector | class definition ].
		browser mondrian
			title: 'Complexity';
			painting: [ :view :category :class :selector |
				view nodeShape 
					height: [ :model | model linesOfCode min: 50 max: 5 ];
					width: [ :model | model instVarNames size + 5 ];
					fillColor: [ :model | model = class ifTrue: [ Color red ] ifFalse: [ Color white ] ].
				view nodes: ((Smalltalk organization listAtCategoryNamed: category)
					collect: [ :each | Smalltalk classNamed: each ]).
				view edgesFrom: [ :each | each superclass ].
				view treeLayout ];
			when: [ :category :class :selector | category notNil ] ]! !

Object subclass: #GLMSTModel
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

GLMSTModel subclass: #GLMSTBehavior
	instanceVariableNames: 'stBehavior'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:09'!
categories
	^ self stBehavior organization categories collect: [:each |
		GLMSTCategory new name: each; glmClass: self; yourself]! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:38'!
comment
	^ self stBehavior comment! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:38'!
definition
	^ self stBehavior definition! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/11/2009 19:11'!
metaSide
	^ (GLMSTClass named: self name) 
		stBehavior: self stBehavior class;
		yourself! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:12'!
name
	^ self stBehavior name! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:39'!
sourceCodeAt: aSelector
	^ self stBehavior sourceCodeAt: aSelector! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:54'!
stBehavior
	^ stBehavior! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:54'!
stBehavior: anObject
	stBehavior := anObject! !

!GLMSTBehavior methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:55'!
traits
	^ self stBehavior traitComposition traits collect: [:each |
		GLMSTTrait new stBehavior: each; yourself]! !

GLMSTBehavior subclass: #GLMSTClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

GLMSTBehavior subclass: #GLMSTTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

GLMSTModel subclass: #GLMSTCategory
	instanceVariableNames: 'glmClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTCategory methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:39'!
glmClass
	^ glmClass! !

!GLMSTCategory methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:39'!
glmClass: anObject
	glmClass := anObject! !

!GLMSTCategory methodsFor: 'testing' stamp: 'tg 9/6/2009 16:16'!
isCategory
	^ true! !

!GLMSTCategory methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:17'!
methods
	^ (self glmClass stBehavior organization listAtCategoryNamed: self name) asSortedCollection collect: [:each |
		GLMSTMethod new name: each; glmCategory: self; yourself ]! !

!GLMSTCategory methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:39'!
name
	^ name! !

!GLMSTCategory methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:39'!
name: anObject
	name := anObject! !

GLMSTModel subclass: #GLMSTClassCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTClassCategory classSide methodsFor: 'as yet unclassified' stamp: 'tg 9/6/2009 18:57'!
all
	^ Smalltalk organization categories collect: [:each | self named: each]! !

!GLMSTClassCategory methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:09'!
classes
	^ (Smalltalk organization listAtCategoryNamed: self name) collect: [ :className |
		GLMSTClass new stBehavior: (Smalltalk classNamed: className) ]! !

!GLMSTClassCategory methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:35'!
name
	^ name! !

!GLMSTClassCategory methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:35'!
name: anObject
	name := anObject! !

GLMSTModel subclass: #GLMSTMethod
	instanceVariableNames: 'glmCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Examples'!

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:42'!
glmCategory
	^ glmCategory! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:42'!
glmCategory: anObject
	glmCategory := anObject! !

!GLMSTMethod methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isMethod
	^ true! !

!GLMSTMethod methodsFor: 'accessing' stamp: 'tg 9/6/2009 16:47'!
sourceCode
	^ self glmCategory glmClass sourceCodeAt: self name! !

!GLMSTModel classSide methodsFor: 'as yet unclassified' stamp: 'tg 9/6/2009 18:57'!
named: aString
	^ self new
		name: aString;
		yourself! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 16:16'!
isCategory
	^ false! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isClass
	^ false! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isClassCategory
	^ false! !

!GLMSTModel methodsFor: 'testing' stamp: 'tg 9/6/2009 19:01'!
isMethod
	^ false! !

!GLMSTModel methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:52'!
name
	^ name! !

!GLMSTModel methodsFor: 'accessing' stamp: 'tg 9/6/2009 14:52'!
name: anObject
	name := anObject! !

!GLMSTModel methodsFor: 'printing' stamp: 'tg 9/6/2009 16:12'!
printOn: aStream
	aStream nextPutAll: self name! !
